﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
#Event: Connected (Success As Boolean)
#Event: StateChanged (State As String)
Sub Class_Globals
	Private Admin As BluetoothAdmin
	Public Astreams As AsyncStreams
	Private Serial As Serial
	Private PH As Phone
	Private mParent As Object
	Private mEventName As String
	Private lblStatus As Label
	Private ProgressBar1 As ProgressBar
	Public BluetoothState, ConnectionState, DeviceFound As Boolean
	Private DeviceName, DeviceMacAdress As String
	Public CharSet = "UTF-8" As String
	Private sb As StringBuilder
	Public State As String
End Sub


Public Sub Initialize(Parent As Object, EventName As String, StatusLabel As Label, Pgb As ProgressBar)
	mParent = Parent
	mEventName = "BTA" 'EventName
	Log("mParent: " & mParent)
	Log( "EventName:" & EventName)
	lblStatus = StatusLabel
	Log("StatusLabel: " & StatusLabel)
	Admin.Initialize("Admin")
	Log("Admin: " & Admin)
	Serial.Initialize("Serial")
	Log("Serial: " & Serial)
	ProgressBar1 = Pgb
	sb.Initialize
		If Admin.IsEnabled = False Then
		If Admin.Enable = False Then
			ToastMessageShow("Bluetooth module not available", True)
		Else
			ToastMessageShow("Bluetooth module available...", False)
		End If
	Else
		BluetoothState = True
	End If
End Sub

' If previous device has been saved try to reconnect
Public Sub start (filename As String)
	'If Not(connected) And File.Exists(File.DirInternal, filename) Then
	'	DeviceMacAdress = File.ReadString(File.DirInternal, filename)
		Connect(DeviceMacAdress)
	'End If
End Sub

Public Sub Connect(Name As String)
	If Name = "HC-05" Then Connect(Name)
	DeviceName = Name
	Dim success As Boolean = Admin.StartDiscovery
	If success = False Then
		lblStatus.Text = "Search process error"
	Else
		lblStatus.Text = "device search in progress "
		ProgressBar1.Visible = True
	End If
End Sub

Public Sub Disconnect
	If Astreams.IsInitialized Then
		 Astreams.Close
	End If
	If Serial.IsInitialized Then Serial.Disconnect
End Sub

Private Sub Admin_DeviceFound (Name As String, MacAddress As String)
	Log("Name:" & Name & CRLF &  "MacAdress:" &  MacAddress)
	
	If Name.Contains("HC-05") Then
		DeviceName = Name
		Log(DeviceName & " found")
		DeviceMacAdress = MacAddress
		If PH.SdkVersion <= 34 Then
			Admin.CancelDiscovery
			lblStatus.Text = DeviceName & " found"
		Else
			lblStatus.Text = DeviceName & " found, please wait."
		End If
	End If
End Sub

Private Sub Admin_DiscoveryFinished
	If DeviceName <> "HC-05" Then
		lblStatus.Text = "Module " & DeviceName & " not detected"
		Msgbox2Async("The HC-05 Bluetooth Module does not seem to be powered, turn on the turtle, the module's red mini-LED should flash quickly then press the Connection button again.","Check the module power supply","OK ", "", "", Null, True)
	Wait For Msgbox_Result (Result As Int)
		Else
		lblStatus.Text = "Connection to " & DeviceName
		Serial.Connect(DeviceMacAdress)
	End If
End Sub

'Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
'	Log("Status change: " & NewState)
	'lblStatus.Text = "Actual status: " & NewState
	'BluetoothState = NewState = Admin.STATE_ON
'End Sub

Sub Serial_Connected (Success As Boolean)
	Private msg As String
	If Success = True Then
		If Astreams.IsInitialized Then Astreams.Close
		Astreams.Initialize(Serial.InputStream, Serial.OutputStream, "Astreams")
		msg = "HC-05 Bluetooth Module connected"
		ProgressBar1.Visible = False
	Else
		msg = LastException.Message 'renvoie la dernière exception interceptée (si elle existe)
		If msg <> "" Then Log(LastException.Message)
	End If
	lblStatus.Text = msg
	CallSubDelayed2(mParent, mEventName & "_Connected", Success)
End Sub

Public Sub SendBytes(Buffer() As Byte)
	Astreams.Write(Buffer)
End Sub

Private Sub Astreams_Terminated
	CallSubDelayed(mParent, mEventName & "_Finished")
End Sub

'Private Sub Astreams_Error
'	Log("error: " & LastException)
'	Astreams.Close
'	CallSubDelayed(mParent, mEventName & "_Finished")
'End Sub

Public Sub Close
	Astreams.Close
End Sub
